#pragma once

#include "CoreMinimal.h"
#include "GameFramework/Actor.h"
#include "EExposerInstanceAreaLocation.h"
#include "SurvivorExposerInstance.generated.h"

UCLASS(Blueprintable, Abstract)
class DEADBYDAYLIGHT_API ASurvivorExposerInstance : public AActor
{
	GENERATED_BODY()

private:
	UPROPERTY(EditInstanceOnly, BlueprintReadWrite, ReplicatedUsing=OnRep_OnAreaLocationChanged, Transient, meta=(AllowPrivateAccess=true))
	EExposerInstanceAreaLocation _areaLocation;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	FString _audioAggravationLevelRtpc;

	UPROPERTY(EditInstanceOnly, BlueprintReadWrite, ReplicatedUsing=OnRep_AggravationLevel, Transient, meta=(AllowPrivateAccess=true))
	float _aggravationLevel;

public:
	UFUNCTION(BlueprintCallable, BlueprintNativeEvent)
	void StartSpawnSequence(bool withRandomDelay);

	UFUNCTION(BlueprintCallable, BlueprintNativeEvent)
	void StartExitSequence(bool withRandomDelay);

protected:
	UFUNCTION(BlueprintCallable, BlueprintImplementableEvent)
	void SetIsInteriorBP(bool interior);

	UFUNCTION(BlueprintCallable)
	void OnRep_OnAreaLocationChanged(EExposerInstanceAreaLocation oldValue);

	UFUNCTION(BlueprintCallable)
	void OnRep_AggravationLevel();

public:
	UFUNCTION(BlueprintPure)
	EExposerInstanceAreaLocation GetAreaLocation() const;

	UFUNCTION(BlueprintCallable)
	void ExitSequenceComplete();

public:
	virtual void GetLifetimeReplicatedProps(TArray<FLifetimeProperty>& OutLifetimeProps) const override;

public:
	ASurvivorExposerInstance();
};

FORCEINLINE uint32 GetTypeHash(const ASurvivorExposerInstance) { return 0; }
